# Reflowio

This package serves to provide a local version of the reflow.io testing automation service.

See documentation at https://reflow.io for up to date information.

This package relies on external APIs to provide its services. These APIs may change, and become out of sync with this package. Please install the latest version available if you run into any problems.

In general, this package is under active development, and is considered beta. As such, it is likely to have bugs. If this is the latest version, please report any bugs to support@reflow.io

## Quick Start

The reflow dashboard is spawned via:

`npx reflowio dashboard`

To access the dashboard, you will need to create an account or login to the site at http://localhost:3100. Login credentials will be securely communicated via cognito.

Once accessed, configuration will be synchronized from the cloud site for logged in users to provide services.

Please be aware, that the local server is only secure when used locally. It is exposed by HTTP only and is thus considered non-secure when accessed via the local network.

## Help

`npx reflowio --help`

## Verbose mode

`npx reflowio --verbose`